'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.onBoardingAddFirstProvider = onBoardingAddFirstProvider;
exports.onBoardingAddSecondProvider = onBoardingAddSecondProvider;
exports.onBoardingAddFirstSearch = onBoardingAddFirstSearch;
exports.onBoardingAddFirstUnifiedView = onBoardingAddFirstUnifiedView;
exports.onBoardingSkip = onBoardingSkip;
exports.onBoardingComplete = onBoardingComplete;
exports.onBoardingAddFirstUser = onBoardingAddFirstUser;

var _constants = require('../constants');

var _constants2 = _interopRequireDefault(_constants);

var _tracking = require('cluedin-core/tracking');

var _fromServer = require('cluedin-core/fromServer');

var _fromServer2 = _interopRequireDefault(_fromServer);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var requestOnBoardingAddFirstProvider = function requestOnBoardingAddFirstProvider() {
  return (0, _tracking.trackable)({
    type: _constants2.default.ONBOARDING_ADD_FIRST_PROVIDER
  }, 'ONBOARDING_ADD_FIRST_PROVIDER', { orgName: _fromServer2.default.clientId });
};

function onBoardingAddFirstProvider() {
  return function (dispatch) {
    dispatch(requestOnBoardingAddFirstProvider());
  };
}

var requestOnBoardingAddSecondProvider = function requestOnBoardingAddSecondProvider() {
  return (0, _tracking.trackable)({
    type: _constants2.default.ONBOARDING_ADD_SECOND_PROVIDER
  }, 'ONBOARDING_ADD_SECOND_PROVIDER', { orgName: _fromServer2.default.clientId });
};

function onBoardingAddSecondProvider() {
  return function (dispatch) {
    dispatch(requestOnBoardingAddSecondProvider());
  };
}

var requestOnBoardingFirstSearch = function requestOnBoardingFirstSearch(q) {
  return (0, _tracking.trackable)({
    type: _constants2.default.ONBOARDING_FIRST_SEARCH
  }, 'ONBOARDING_FIRST_SEARCH', { orgName: _fromServer2.default.clientId, q: q });
};

function onBoardingAddFirstSearch() {
  return function (dispatch) {
    dispatch(requestOnBoardingFirstSearch());
  };
}

var requestOnBoardingFirstUnifiedView = function requestOnBoardingFirstUnifiedView(entity) {
  return (0, _tracking.trackable)({
    type: _constants2.default.ONBOARDING_FIRST_UNIFIED_VIEW
  }, 'ONBOARDING_FIRST_UNIFIED_VIEW', {
    orgName: _fromServer2.default.clientId,
    id: entity.id,
    entityType: entity.data.entityType,
    name: entity.name
  });
};

function onBoardingAddFirstUnifiedView() {
  return function (dispatch) {
    dispatch(requestOnBoardingFirstUnifiedView());
  };
}

var requestOnBoardingSkip = function requestOnBoardingSkip() {
  return (0, _tracking.trackable)({
    type: _constants2.default.ONBOARDING_SKIP
  }, 'ONBOARDING_SKIP', { orgName: _fromServer2.default.clientId });
};

function onBoardingSkip() {
  return function (dispatch) {
    dispatch(requestOnBoardingSkip());
  };
}

var requestOnBoardingComplete = function requestOnBoardingComplete() {
  return (0, _tracking.trackable)({
    type: _constants2.default.ONBOARDING_COMPLETE
  }, 'ONBOARDING_COMPLETE', { orgName: _fromServer2.default.clientId });
};

function onBoardingComplete() {
  return function (dispatch) {
    dispatch(requestOnBoardingComplete());
  };
}

var requestOnBoardingAddFirstUser = function requestOnBoardingAddFirstUser() {
  return (0, _tracking.trackable)({
    type: _constants2.default.ONBOARDING_ADD_FIRST_USER
  }, 'ONBOARDING_ADD_FIRST_USER', { orgName: _fromServer2.default.clientId });
};

function onBoardingAddFirstUser() {
  return function (dispatch) {
    dispatch(requestOnBoardingComplete());
  };
}