'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactRouter = require('react-router');

var _fromServer = require('cluedin-core/fromServer');

var _image = require('cluedin-core/iso/image');

var _ListItem = require('cluedin-ui/List/ListItem');

var _ListItem2 = _interopRequireDefault(_ListItem);

var _entity = require('cluedin-core/entity');

var _Button = require('cluedin-ui/Button');

var _Button2 = _interopRequireDefault(_Button);

var _reactIntl = require('react-intl');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var DomainUserStyle = {
  logoContainer: {
    width: '48px',
    textAlign: 'center',
    height: '48px',
    paddingLeft: '10px'
  },
  logo: {
    width: '100%',
    borderRadius: '2px'
  },
  action: {
    textAlign: 'right',
    paddingRight: '15px',
    flex: 1
  }
};

var DomainUser = function (_Component) {
  (0, _inherits3.default)(DomainUser, _Component);

  function DomainUser() {
    (0, _classCallCheck3.default)(this, DomainUser);
    return (0, _possibleConstructorReturn3.default)(this, (DomainUser.__proto__ || (0, _getPrototypeOf2.default)(DomainUser)).apply(this, arguments));
  }

  (0, _createClass3.default)(DomainUser, [{
    key: 'invite',
    value: function invite() {
      var _props = this.props,
          domainUser = _props.domainUser,
          inviteClick = _props.inviteClick;

      var email = domainUser.Properties.MetadataDictionary['property-user.email'];
      var name = domainUser.Name;

      inviteClick(email, name);
    }
  }, {
    key: 'render',
    value: function render() {
      var domainUser = this.props.domainUser;

      var content = void 0;
      var imageProfile = void 0;
      var inviteButtonContent = void 0;
      var inviteMessage = _react2.default.createElement(_reactIntl.FormattedMessage, { id: 'DomainUser.AddTeamMember' });
      var nameStyle = { paddingLeft: '15px' };

      if (domainUser.Properties && domainUser.Properties.MetadataDictionary && domainUser.Properties.MetadataDictionary['property-user.email']) {
        inviteButtonContent = _react2.default.createElement(
          'div',
          { style: DomainUserStyle.action },
          _react2.default.createElement(_Button2.default, { click: this.invite.bind(this), message: inviteMessage })
        );
      }

      if (domainUser.PreviewUrl) {
        var imageUrl = (0, _image.addTokenToImage)(domainUser.PreviewUrl, (0, _fromServer.getCurrentToken)());

        imageProfile = _react2.default.createElement(
          'div',
          { style: DomainUserStyle.logoContainer },
          _react2.default.createElement(
            _reactRouter.Link,
            { to: (0, _entity.getEntityLink)(domainUser.Id, domainUser.EntityType) },
            _react2.default.createElement('img', { style: DomainUserStyle.logo, src: imageUrl })
          )
        );
      }

      content = _react2.default.createElement(
        'div',
        { style: { flex: 1 } },
        _react2.default.createElement(
          _reactRouter.Link,
          { to: (0, _entity.getEntityLink)(domainUser.Id, domainUser.EntityType) },
          _react2.default.createElement(
            'strong',
            { style: nameStyle },
            domainUser.Name
          )
        )
      );

      return _react2.default.createElement(
        _ListItem2.default,
        null,
        _react2.default.createElement(
          'div',
          { style: { display: 'flex', lineHeight: '48px' } },
          imageProfile,
          content,
          inviteButtonContent
        )
      );
    }
  }]);
  return DomainUser;
}(_react.Component);

exports.default = DomainUser;
process.env.NODE_ENV !== "production" ? DomainUser.propTypes = {
  inviteClick: _propTypes2.default.func,
  domainUser: _propTypes2.default.object
} : void 0;