'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _ListItem = require('cluedin-ui/List/ListItem');

var _ListItem2 = _interopRequireDefault(_ListItem);

var _InvitationMenu = require('./InvitationMenu');

var _InvitationMenu2 = _interopRequireDefault(_InvitationMenu);

var _MiniLoading = require('cluedin-ui/Loading/MiniLoading');

var _MiniLoading2 = _interopRequireDefault(_MiniLoading);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var InvitationRowStyle = {
  action: {
    textAlign: 'right',
    flex: 1
  },
  errorMsg: {
    marginLeft: '16px',
    color: '#d13f48'
  }
};

var InvitationRow = function (_Component) {
  (0, _inherits3.default)(InvitationRow, _Component);

  function InvitationRow() {
    (0, _classCallCheck3.default)(this, InvitationRow);
    return (0, _possibleConstructorReturn3.default)(this, (InvitationRow.__proto__ || (0, _getPrototypeOf2.default)(InvitationRow)).apply(this, arguments));
  }

  (0, _createClass3.default)(InvitationRow, [{
    key: 'onResendClickHandler',
    value: function onResendClickHandler(invitation) {
      var onResend = this.props.onResend;


      if (onResend) {
        onResend(invitation);
      }
    }
  }, {
    key: 'onRemoveClickHandler',
    value: function onRemoveClickHandler(invitation) {
      var onRemove = this.props.onRemove;


      if (onRemove) {
        onRemove(invitation);
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          invitation = _props.invitation,
          isLoading = _props.isLoading,
          hasError = _props.hasError;

      var content = void 0;
      var nameStyle = { paddingLeft: '15px' };
      var invitationMenu = void 0;

      var errorContent = hasError ? _react2.default.createElement(
        'span',
        { style: InvitationRowStyle.errorMsg },
        'Something odd happened! The action failed.'
      ) : null;

      content = _react2.default.createElement(
        'div',
        { style: { flex: 1 } },
        _react2.default.createElement(
          'strong',
          { style: nameStyle },
          invitation.email
        ),
        errorContent
      );

      if (isLoading) {
        invitationMenu = _react2.default.createElement(
          'div',
          { style: { paddingTop: '15px', paddingRight: '15px' } },
          _react2.default.createElement(_MiniLoading2.default, null)
        );
      } else {
        invitationMenu = _react2.default.createElement(_InvitationMenu2.default, { invitation: invitation,
          onResend: this.onResendClickHandler.bind(this, invitation),
          onRemove: this.onRemoveClickHandler.bind(this, invitation)
        });
      }

      return _react2.default.createElement(
        _ListItem2.default,
        null,
        _react2.default.createElement(
          'div',
          { style: { display: 'flex' } },
          _react2.default.createElement(
            'div',
            { style: { display: 'flex', lineHeight: '48px' } },
            content
          ),
          _react2.default.createElement(
            'div',
            { style: InvitationRowStyle.action },
            invitationMenu
          )
        )
      );
    }
  }]);
  return InvitationRow;
}(_react.Component);

exports.default = InvitationRow;
process.env.NODE_ENV !== "production" ? InvitationRow.propTypes = {
  onResend: _propTypes2.default.func,
  onRemove: _propTypes2.default.func,
  invitation: _propTypes2.default.object,
  isLoading: _propTypes2.default.bool,
  hasError: _propTypes2.default.bool
} : void 0;