'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _MainAllUserRow = require('./MainAllUserRow');

var _MainAllUserRow2 = _interopRequireDefault(_MainAllUserRow);

var _List = require('cluedin-ui/List/List');

var _List2 = _interopRequireDefault(_List);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var MainAllUserList = function MainAllUserList(_ref) {
  var users = _ref.users,
      onPromoteClick = _ref.onPromoteClick,
      onDemoteClick = _ref.onDemoteClick,
      onDeActivateClick = _ref.onDeActivateClick,
      onActivateClick = _ref.onActivateClick,
      currentUser = _ref.currentUser,
      promoteUsers = _ref.promoteUsers,
      demoteUsers = _ref.demoteUsers,
      blockUsers = _ref.blockUsers,
      unBlockUsers = _ref.unBlockUsers,
      isAdmin = _ref.isAdmin;
  return _react2.default.createElement(
    _List2.default,
    null,
    users.map(function (user, i) {
      var isPromoting = promoteUsers[user.Account.UserName];
      var isDemoting = demoteUsers[user.Account.UserName];
      var isBlocking = blockUsers[user.Account.UserName];
      var isUnblocking = unBlockUsers[user.Account.UserName];
      var isPromotingFetching = void 0;
      var isDemotingFetching = void 0;
      var isBlockingFetching = void 0;
      var isUnblockingFetching = void 0;
      var isLoading = void 0;

      if (isPromoting) {
        isPromotingFetching = isPromoting.isFetching;
      }

      if (isDemoting) {
        isDemotingFetching = isDemoting.isFetching;
      }

      if (isBlocking) {
        isBlockingFetching = isBlocking.isFetching;
      }

      if (isUnblocking) {
        isUnblockingFetching = isUnblocking.isFetching;
      }

      isLoading = isPromotingFetching || isDemotingFetching || isBlockingFetching || isUnblockingFetching;

      return _react2.default.createElement(_MainAllUserRow2.default, {
        key: i,
        user: user,
        isLoading: isLoading,
        onPromoteClick: onPromoteClick,
        onDemoteClick: onDemoteClick,
        onDeActivateClick: onDeActivateClick,
        onActivateClick: onActivateClick,
        currentUser: currentUser,
        isAdmin: isAdmin
      });
    })
  );
};

process.env.NODE_ENV !== "production" ? MainAllUserList.propTypes = {
  users: _propTypes2.default.array.isRequired,
  onPromoteClick: _propTypes2.default.func.isRequired,
  onDemoteClick: _propTypes2.default.func.isRequired,
  onDeActivateClick: _propTypes2.default.func.isRequired,
  onActivateClick: _propTypes2.default.func.isRequired,
  currentUser: _propTypes2.default.object,
  promoteUsers: _propTypes2.default.object,
  demoteUsers: _propTypes2.default.object,
  blockUsers: _propTypes2.default.object,
  unBlockUsers: _propTypes2.default.object
} : void 0;

exports.default = MainAllUserList;