'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactRouter = require('react-router');

var _entity = require('cluedin-core/entity');

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _ListItem = require('cluedin-ui/List/ListItem');

var _ListItem2 = _interopRequireDefault(_ListItem);

var _accountBox = require('material-ui/svg-icons/action/account-box');

var _accountBox2 = _interopRequireDefault(_accountBox);

var _Badge = require('cluedin-ui/Badge');

var _Badge2 = _interopRequireDefault(_Badge);

var _MiniLoading = require('cluedin-ui/Loading/MiniLoading');

var _MiniLoading2 = _interopRequireDefault(_MiniLoading);

var _UserMenu = require('./UserMenu');

var _UserMenu2 = _interopRequireDefault(_UserMenu);

var _reactIntl = require('react-intl');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var MainAllUserListRowStyle = {
  logoContainer: {
    width: '48px',
    textAlign: 'center',
    height: '48px',
    paddingLeft: '10px'
  },
  logo: {
    width: '100%',
    borderRadius: '2px'
  },
  title: {
    margin: '0px 0px 5px 0px',
    padding: 0,
    fontSize: '20px',
    fontFamily: 'sans-serif',
    fontWeight: '500',
    display: 'inline-block'
  },
  action: {
    textAlign: 'right',
    flex: 1
  },
  descriptionContainer: {
    flex: 1,
    display: 'flex'
  },
  descriptionContainerContent: {
    flex: 1,
    padding: '0 15px'
  },
  details: {
    fontSize: '14px',
    color: '#9e9ea6'
  },
  viewIntegrationButton: {
    marginRight: '15px'
  }
};

var MainAllUserListRow = function (_Component) {
  (0, _inherits3.default)(MainAllUserListRow, _Component);

  function MainAllUserListRow() {
    (0, _classCallCheck3.default)(this, MainAllUserListRow);
    return (0, _possibleConstructorReturn3.default)(this, (MainAllUserListRow.__proto__ || (0, _getPrototypeOf2.default)(MainAllUserListRow)).apply(this, arguments));
  }

  (0, _createClass3.default)(MainAllUserListRow, [{
    key: 'onPromoteClickHandler',
    value: function onPromoteClickHandler(user) {
      var onPromoteClick = this.props.onPromoteClick;


      if (onPromoteClick) {
        onPromoteClick(user);
      }
    }
  }, {
    key: 'onDemoteClickHandler',
    value: function onDemoteClickHandler(user) {
      var onDemoteClick = this.props.onDemoteClick;


      if (onDemoteClick) {
        onDemoteClick(user);
      }
    }
  }, {
    key: 'onDeActivateClickHandler',
    value: function onDeActivateClickHandler(user) {
      var onDeActivateClick = this.props.onDeActivateClick;


      if (onDeActivateClick) {
        onDeActivateClick(user);
      }
    }
  }, {
    key: 'onActivateClickHandler',
    value: function onActivateClickHandler(user) {
      var onActivateClick = this.props.onActivateClick;


      if (onActivateClick) {
        onActivateClick(user);
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          user = _props.user,
          currentUser = _props.currentUser,
          isLoading = _props.isLoading,
          isAdmin = _props.isAdmin;

      var userImageUrl = void 0;
      var adminBadge = void 0;
      var thisIsYouBadge = void 0;
      var inactiveBadge = void 0;
      var userMenu = void 0;
      var profileImageContent = void 0;
      var entityNameContent = void 0;

      if (user.Account.IsAdmin) {
        adminBadge = _react2.default.createElement(
          _Badge2.default,
          { type: 'error', style: { margin: '0 0 0 5px' } },
          _react2.default.createElement(_reactIntl.FormattedMessage, { id: 'UserMenu.Admin' })
        );
      }

      if (user.Account.LockoutEnabled) {
        inactiveBadge = _react2.default.createElement(
          _Badge2.default,
          { type: 'warning', style: { margin: '0 0 0 5px' } },
          _react2.default.createElement(_reactIntl.FormattedMessage, { id: 'UserMenu.Inactive' })
        );
      }

      if (currentUser && currentUser.client.UserName === user.Account.UserName) {
        thisIsYouBadge = _react2.default.createElement(
          _Badge2.default,
          { style: { margin: '0 0 0 5px' } },
          _react2.default.createElement(_reactIntl.FormattedMessage, { id: 'UserMenu.You' })
        );
      } else {
        if (isLoading) {
          userMenu = _react2.default.createElement(
            'div',
            { style: { paddingTop: '15px', paddingRight: '15px' } },
            _react2.default.createElement(_MiniLoading2.default, null)
          );
        } else {
          if (isAdmin) {
            userMenu = _react2.default.createElement(_UserMenu2.default, {
              user: user,
              onPromoteClick: this.onPromoteClickHandler.bind(this, user),
              onDemoteClick: this.onDemoteClickHandler.bind(this, user),
              onDeActivateClick: this.onDeActivateClickHandler.bind(this, user),
              onActivateClick: this.onActivateClickHandler.bind(this, user)
            });
          }
        }
      }

      if (!user.Entity || !user.Entity.hasLogo) {
        userImageUrl = _react2.default.createElement(_accountBox2.default, { style: { width: '48px', height: '48px' } });
      } else {
        userImageUrl = _react2.default.createElement('img', { style: MainAllUserListRowStyle.logo, alt: user.Account.UserName, src: '' + user.Entity.logoUrl });
      }

      if (user.Entity) {
        profileImageContent = _react2.default.createElement(
          _reactRouter.Link,
          { to: (0, _entity.getEntityLink)(user.Entity.id, user.Entity.data.entityType) },
          userImageUrl
        );
        entityNameContent = _react2.default.createElement(
          _reactRouter.Link,
          { to: (0, _entity.getEntityLink)(user.Entity.id, user.Entity.data.entityType) },
          _react2.default.createElement(
            'h4',
            {
              style: MainAllUserListRowStyle.title },
            user.Account.UserName
          )
        );
      } else {
        profileImageContent = userImageUrl;
        entityNameContent = _react2.default.createElement(
          'h4',
          { style: MainAllUserListRowStyle.title },
          user.Account.UserName
        );
      }

      return _react2.default.createElement(
        _ListItem2.default,
        null,
        _react2.default.createElement(
          'div',
          { style: { display: 'flex' } },
          _react2.default.createElement(
            'div',
            { style: MainAllUserListRowStyle.logoContainer },
            profileImageContent
          ),
          _react2.default.createElement(
            'div',
            { style: MainAllUserListRowStyle.descriptionContainer },
            _react2.default.createElement(
              'div',
              { style: MainAllUserListRowStyle.descriptionContainerContent },
              _react2.default.createElement(
                'div',
                null,
                entityNameContent
              ),
              _react2.default.createElement(
                'div',
                { style: MainAllUserListRowStyle.details },
                _react2.default.createElement(
                  'span',
                  { style: { marginRight: '5px' } },
                  user.Account.Email
                ),
                adminBadge,
                thisIsYouBadge,
                inactiveBadge
              )
            ),
            _react2.default.createElement(
              'div',
              { style: MainAllUserListRowStyle.action },
              userMenu
            )
          )
        )
      );
    }
  }]);
  return MainAllUserListRow;
}(_react.Component);

process.env.NODE_ENV !== "production" ? MainAllUserListRow.propTypes = {
  user: _propTypes2.default.object,
  currentUser: _propTypes2.default.object,
  onPromoteClick: _propTypes2.default.func.isRequired,
  onDemoteClick: _propTypes2.default.func.isRequired,
  onDeActivateClick: _propTypes2.default.func.isRequired,
  onActivateClick: _propTypes2.default.func.isRequired,
  isLoading: _propTypes2.default.bool
} : void 0;
exports.default = (0, _radium2.default)(MainAllUserListRow);