'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _LinearProgress = require('material-ui/LinearProgress');

var _LinearProgress2 = _interopRequireDefault(_LinearProgress);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var PasswordAdviser = function (_Component) {
  (0, _inherits3.default)(PasswordAdviser, _Component);

  function PasswordAdviser() {
    (0, _classCallCheck3.default)(this, PasswordAdviser);
    return (0, _possibleConstructorReturn3.default)(this, (PasswordAdviser.__proto__ || (0, _getPrototypeOf2.default)(PasswordAdviser)).apply(this, arguments));
  }

  (0, _createClass3.default)(PasswordAdviser, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          score = _props.score,
          suggestions = _props.suggestions;

      var scoreColor = void 0;
      var scoreInPercent = void 0;
      var scoreLabel = void 0;
      var suggestionsContent = void 0;

      if (score) {
        scoreInPercent = score / 4 * 100;
        if (score === 0) {
          scoreColor = 'red';
          scoreLabel = 'Very Weak';
        }

        if (score === 1 || score === 2) {
          scoreColor = 'orange';
          scoreLabel = 'Weak';
        }

        if (score === 3) {
          scoreLabel = 'Good';
        }

        if (score === 4) {
          scoreColor = '#06979e';
          scoreLabel = 'Solid';
        }
      } else {
        scoreLabel = 'Very weak';
      }

      if (suggestions && suggestions.length > 0) {
        suggestionsContent = _react2.default.createElement(
          'div',
          null,
          _react2.default.createElement(
            'h4',
            { style: { margin: 0 } },
            'Advise(s) for better password'
          ),
          _react2.default.createElement(
            'div',
            { style: { fontSize: '12px' } },
            _react2.default.createElement(
              'ul',
              { style: { margin: '15px 0 0 0', padding: 0, listStyle: 'none' } },
              suggestions && suggestions.map(function (suggestion, index) {
                return _react2.default.createElement(
                  'li',
                  { style: { margin: '5px 0' }, key: index },
                  suggestion
                );
              })
            )
          )
        );
      }

      return _react2.default.createElement(
        'div',
        null,
        _react2.default.createElement(
          'div',
          { style: { marginBottom: '15px' } },
          _react2.default.createElement(
            'h3',
            { style: { margin: 0 } },
            'Password Adviser'
          )
        ),
        _react2.default.createElement(
          'div',
          null,
          _react2.default.createElement(
            'h4',
            { style: { margin: 0 } },
            'Strength Scale'
          )
        ),
        _react2.default.createElement(
          'div',
          { style: { margin: '15px 0' } },
          _react2.default.createElement(_LinearProgress2.default, { style: { height: '8px' }, color: scoreColor, mode: 'determinate', value: scoreInPercent }),
          _react2.default.createElement(
            'span',
            { style: { fontSize: '12px' } },
            scoreLabel
          )
        ),
        suggestionsContent
      );
    }
  }]);
  return PasswordAdviser;
}(_react.Component);

exports.default = PasswordAdviser;