'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _IconMenu = require('material-ui/IconMenu');

var _IconMenu2 = _interopRequireDefault(_IconMenu);

var _MenuItem = require('material-ui/MenuItem');

var _MenuItem2 = _interopRequireDefault(_MenuItem);

var _IconButton = require('material-ui/IconButton');

var _IconButton2 = _interopRequireDefault(_IconButton);

var _moreVert = require('material-ui/svg-icons/navigation/more-vert');

var _moreVert2 = _interopRequireDefault(_moreVert);

var _reactIntl = require('react-intl');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var UserMenu = function UserMenu(_ref) {
  var user = _ref.user,
      onPromoteClick = _ref.onPromoteClick,
      onDemoteClick = _ref.onDemoteClick,
      onDeActivateClick = _ref.onDeActivateClick,
      onActivateClick = _ref.onActivateClick;

  var adminAction = void 0;
  var activateAction = void 0;

  if (user.Account.IsAdmin) {
    adminAction = _react2.default.createElement(_MenuItem2.default, { onClick: onDemoteClick, primaryText: _react2.default.createElement(_reactIntl.FormattedMessage, { id: 'UserMenu.DemoteAction' }) });
  } else {
    adminAction = _react2.default.createElement(_MenuItem2.default, { onClick: onPromoteClick, primaryText: _react2.default.createElement(_reactIntl.FormattedMessage, { id: 'UserMenu.PromoteAction' }) });
  }

  if (user.Account.LockoutEnabled) {
    activateAction = _react2.default.createElement(_MenuItem2.default, { onClick: onActivateClick, primaryText: _react2.default.createElement(_reactIntl.FormattedMessage, { id: 'UserMenu.Activate' }) });
  } else {
    activateAction = _react2.default.createElement(_MenuItem2.default, { onClick: onDeActivateClick, primaryText: _react2.default.createElement(_reactIntl.FormattedMessage, { id: 'UserMenu.Deactivate' }) });
  }

  return _react2.default.createElement(
    _IconMenu2.default,
    {
      iconButtonElement: _react2.default.createElement(
        _IconButton2.default,
        null,
        _react2.default.createElement(_moreVert2.default, null)
      ),
      anchorOrigin: { horizontal: 'right', vertical: 'top' },
      targetOrigin: { horizontal: 'right', vertical: 'top' }
    },
    adminAction,
    activateAction
  );
};

process.env.NODE_ENV !== "production" ? UserMenu.propTypes = {
  user: _propTypes2.default.object,
  onDemoteClick: _propTypes2.default.func,
  onPromoteClick: _propTypes2.default.func,
  onDeActivateClick: _propTypes2.default.func,
  onActivateClick: _propTypes2.default.func
} : void 0;

exports.default = UserMenu;