'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _InvitationList = require('../components/InvitationList');

var _InvitationList2 = _interopRequireDefault(_InvitationList);

var _reducers = require('../reducers');

var _reactRedux = require('react-redux');

var _Widget = require('cluedin-ui/Widget');

var _reactIntl = require('react-intl');

var _actions = require('../actions');

var _Alert = require('cluedin-ui/Alert');

var _Alert2 = _interopRequireDefault(_Alert);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var addUserNameToInvit = function addUserNameToInvit(invit, currentUser) {
  return (0, _extends3.default)({}, invit, {
    userName: currentUser.client.UserName
  });
};

var AllInvitations = function (_Component) {
  (0, _inherits3.default)(AllInvitations, _Component);

  function AllInvitations() {
    (0, _classCallCheck3.default)(this, AllInvitations);
    return (0, _possibleConstructorReturn3.default)(this, (AllInvitations.__proto__ || (0, _getPrototypeOf2.default)(AllInvitations)).apply(this, arguments));
  }

  (0, _createClass3.default)(AllInvitations, [{
    key: 'componentWillMount',
    value: function componentWillMount() {
      this.props.dispatch((0, _actions.shouldFetchInvitations)());
    }
  }, {
    key: 'onResendHandler',
    value: function onResendHandler(invitation) {
      var currentUser = this.props.currentUser;

      var invitWithUserName = addUserNameToInvit(invitation, currentUser);
      this.props.dispatch((0, _actions.shouldResendInvitation)(invitWithUserName));
    }
  }, {
    key: 'onRemoveHandler',
    value: function onRemoveHandler(invitation) {
      var currentUser = this.props.currentUser;

      var invitWithUserName = addUserNameToInvit(invitation, currentUser);
      this.props.dispatch((0, _actions.shouldRemoveInvitation)(invitWithUserName));
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          allInvitations = _props.allInvitations,
          isFetchingAllInvitations = _props.isFetchingAllInvitations,
          sendInvitations = _props.sendInvitations,
          removeInvitations = _props.removeInvitations;

      var content = void 0;
      var isFetching = isFetchingAllInvitations || !allInvitations;

      if (allInvitations && allInvitations.length > 0) {
        content = _react2.default.createElement(_InvitationList2.default, {
          invitations: allInvitations,
          sendInvitations: sendInvitations,
          removeInvitations: removeInvitations,
          onResend: this.onResendHandler.bind(this),
          onRemove: this.onRemoveHandler.bind(this)
        });
      } else {
        content = _react2.default.createElement(
          _Alert2.default,
          null,
          'Currently no active invitation.'
        );
      }

      return _react2.default.createElement(_Widget.WidgetWithLoading, {
        isLoading: isFetching,
        name: _react2.default.createElement(_reactIntl.FormattedMessage, { id: 'AllInvitation.Title' }),
        content: content
      });
    }
  }]);
  return AllInvitations;
}(_react.Component);

process.env.NODE_ENV !== "production" ? AllInvitations.propTypes = {
  allInvitations: _propTypes2.default.array,
  isFetchingAllInvitations: _propTypes2.default.bool,
  sendInvitations: _propTypes2.default.object,
  removeInvitations: _propTypes2.default.object,
  currentUser: _propTypes2.default.object,
  dispatch: _propTypes2.default.func
} : void 0;


var select = function select(_ref) {
  var _ref$storeName = _ref[_reducers.storeName],
      allInvitations = _ref$storeName.allInvitations,
      isFetchingAllInvitations = _ref$storeName.isFetchingAllInvitations,
      sendInvitations = _ref$storeName.sendInvitations,
      removeInvitations = _ref$storeName.removeInvitations,
      currentUser = _ref$storeName.currentUser;

  return {
    allInvitations: allInvitations,
    isFetchingAllInvitations: isFetchingAllInvitations,
    sendInvitations: sendInvitations,
    removeInvitations: removeInvitations,
    currentUser: currentUser
  };
};

exports.default = (0, _reactRedux.connect)(select)(AllInvitations);