'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _DomainUsers = require('../components/DomainUsers');

var _DomainUsers2 = _interopRequireDefault(_DomainUsers);

var _reducers = require('../reducers');

var _reactRedux = require('react-redux');

var _index = require('../actions/index');

var _reactIntl = require('react-intl');

var _Alert = require('cluedin-ui/Alert');

var _Alert2 = _interopRequireDefault(_Alert);

var _Widget = require('cluedin-ui/Widget');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var AllPotentialUsers = function (_Component) {
  (0, _inherits3.default)(AllPotentialUsers, _Component);

  function AllPotentialUsers() {
    (0, _classCallCheck3.default)(this, AllPotentialUsers);
    return (0, _possibleConstructorReturn3.default)(this, (AllPotentialUsers.__proto__ || (0, _getPrototypeOf2.default)(AllPotentialUsers)).apply(this, arguments));
  }

  (0, _createClass3.default)(AllPotentialUsers, [{
    key: 'componentWillMount',
    value: function componentWillMount() {
      this.props.dispatch((0, _index.fetchPotentialUsersIfNeeded)());
    }
  }, {
    key: 'inviteClickHandler',
    value: function inviteClickHandler(email, name) {
      this.props.dispatch((0, _index.shouldOpenInviteUserDialog)(email, name));
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          potentialUsers = _props.potentialUsers,
          isFetchingPotentialUsers = _props.isFetchingPotentialUsers;

      var isFetching = isFetchingPotentialUsers || !potentialUsers;

      var content = void 0;

      if (potentialUsers && potentialUsers.length > 0) {
        content = _react2.default.createElement(_DomainUsers2.default, { inviteClick: this.inviteClickHandler.bind(this), potentialUsers: potentialUsers });
      } else {
        content = _react2.default.createElement(
          _Alert2.default,
          null,
          'Currently no potential user found.'
        );
      }

      return _react2.default.createElement(_Widget.WidgetWithLoading, {
        isFetching: isFetching,
        name: _react2.default.createElement(_reactIntl.FormattedMessage, { id: 'AllPotentialUsers.Title' }),
        content: content
      });
    }
  }]);
  return AllPotentialUsers;
}(_react.Component);

process.env.NODE_ENV !== "production" ? AllPotentialUsers.propTypes = {
  currentUser: _propTypes2.default.object,
  potentialUsers: _propTypes2.default.array,
  isFetchingPotentialUsers: _propTypes2.default.bool,
  dispatch: _propTypes2.default.func
} : void 0;


var select = function select(_ref) {
  var _ref$storeName = _ref[_reducers.storeName],
      potentialUsers = _ref$storeName.potentialUsers,
      isFetchingPotentialUsers = _ref$storeName.isFetchingPotentialUsers,
      currentUser = _ref$storeName.currentUser;

  return {
    potentialUsers: potentialUsers,
    isFetchingPotentialUsers: isFetchingPotentialUsers,
    currentUser: currentUser
  };
};

exports.default = (0, _reactRedux.connect)(select)(AllPotentialUsers);