'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactRedux = require('react-redux');

var _reactIntl = require('react-intl');

var _Alert = require('cluedin-ui/Alert');

var _Alert2 = _interopRequireDefault(_Alert);

var _Widget = require('cluedin-ui/Widget');

var _MainAllUserList = require('../components/MainAllUserList');

var _MainAllUserList2 = _interopRequireDefault(_MainAllUserList);

var _reducers = require('../reducers');

var _index = require('../actions/index');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var AllUsers = function (_Component) {
  (0, _inherits3.default)(AllUsers, _Component);

  function AllUsers() {
    (0, _classCallCheck3.default)(this, AllUsers);
    return (0, _possibleConstructorReturn3.default)(this, (AllUsers.__proto__ || (0, _getPrototypeOf2.default)(AllUsers)).apply(this, arguments));
  }

  (0, _createClass3.default)(AllUsers, [{
    key: 'componentWillMount',
    value: function componentWillMount() {
      this.props.dispatch((0, _index.shouldFetchCurrentUser)());
      this.props.dispatch((0, _index.fetchAllUsers)());
    }
  }, {
    key: 'onPromoteClickHandler',
    value: function onPromoteClickHandler(user) {
      this.props.dispatch((0, _index.shouldPromote)(user.Account.UserName));
    }
  }, {
    key: 'onDemoteClickHandler',
    value: function onDemoteClickHandler(user) {
      this.props.dispatch((0, _index.shouldDemote)(user.Account.UserName));
    }
  }, {
    key: 'onDeActivateHandler',
    value: function onDeActivateHandler(user) {
      this.props.dispatch((0, _index.shouldBlock)(user.Account.UserName));
    }
  }, {
    key: 'onActivateHandler',
    value: function onActivateHandler(user) {
      this.props.dispatch((0, _index.shouldUnBlock)(user.Account.UserName));
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          allUsers = _props.allUsers,
          isFetchingAllUsers = _props.isFetchingAllUsers,
          promoteUsers = _props.promoteUsers,
          demoteUsers = _props.demoteUsers,
          blockUsers = _props.blockUsers,
          unBlockUsers = _props.unBlockUsers,
          isFetchingCurrentUser = _props.isFetchingCurrentUser,
          currentUser = _props.currentUser;

      var content = void 0;
      var isAdmin = currentUser ? currentUser.client.IsAdmin : false;

      var isFetching = isFetchingAllUsers || isFetchingCurrentUser || !allUsers;

      if (allUsers && allUsers.length > 0) {
        content = _react2.default.createElement(_MainAllUserList2.default, {
          onPromoteClick: this.onPromoteClickHandler.bind(this),
          onDemoteClick: this.onDemoteClickHandler.bind(this),
          onDeActivateClick: this.onDeActivateHandler.bind(this),
          onActivateClick: this.onActivateHandler.bind(this),
          promoteUsers: promoteUsers,
          demoteUsers: demoteUsers,
          blockUsers: blockUsers,
          unBlockUsers: unBlockUsers,
          currentUser: currentUser,
          isAdmin: isAdmin,
          users: allUsers
        });
      } else {
        content = _react2.default.createElement(
          _Alert2.default,
          null,
          'Currently no active user.'
        );
      }

      return _react2.default.createElement(_Widget.WidgetWithLoading, {
        isLoading: isFetching,
        name: _react2.default.createElement(_reactIntl.FormattedMessage, { id: 'AllUsers.Title' }),
        content: content
      });
    }
  }]);
  return AllUsers;
}(_react.Component);

process.env.NODE_ENV !== "production" ? AllUsers.propTypes = {
  allUsers: _propTypes2.default.array,
  isFetchingAllUsers: _propTypes2.default.bool,
  promoteUsers: _propTypes2.default.object,
  demoteUsers: _propTypes2.default.object,
  blockUsers: _propTypes2.default.object,
  unBlockUsers: _propTypes2.default.object,
  currentUser: _propTypes2.default.object,
  isFetchingCurrentUser: _propTypes2.default.bool,
  dispatch: _propTypes2.default.func
} : void 0;


var select = function select(_ref) {
  var _ref$storeName = _ref[_reducers.storeName],
      allUsers = _ref$storeName.allUsers,
      isFetchingAllUsers = _ref$storeName.isFetchingAllUsers,
      promoteUsers = _ref$storeName.promoteUsers,
      demoteUsers = _ref$storeName.demoteUsers,
      blockUsers = _ref$storeName.blockUsers,
      unBlockUsers = _ref$storeName.unBlockUsers,
      currentUser = _ref$storeName.currentUser,
      isFetchingCurrentUser = _ref$storeName.isFetchingCurrentUser;

  return {
    allUsers: allUsers,
    isFetchingAllUsers: isFetchingAllUsers,
    promoteUsers: promoteUsers,
    demoteUsers: demoteUsers,
    blockUsers: blockUsers,
    unBlockUsers: unBlockUsers,
    currentUser: currentUser,
    isFetchingCurrentUser: isFetchingCurrentUser
  };
};

exports.default = (0, _reactRedux.connect)(select)(AllUsers);