'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactReduxForm = require('react-redux-form');

var _FormDecorator = require('cluedin-ui/Form/Fields/FormDecorator');

var _FormDecorator2 = _interopRequireDefault(_FormDecorator);

var _Button = require('cluedin-ui/Button');

var _Button2 = _interopRequireDefault(_Button);

var _zxcvbn = require('zxcvbn');

var _zxcvbn2 = _interopRequireDefault(_zxcvbn);

var _PasswordAdviser = require('../components/PasswordAdviser');

var _PasswordAdviser2 = _interopRequireDefault(_PasswordAdviser);

var _reactRedux = require('react-redux');

var _actions = require('../actions');

var _Alert = require('cluedin-ui/Alert');

var _Alert2 = _interopRequireDefault(_Alert);

var _MiniLoading = require('cluedin-ui/Loading/MiniLoading');

var _MiniLoading2 = _interopRequireDefault(_MiniLoading);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var inputStyle = {
  width: '100%',
  padding: '5px 8px',
  margin: '10px 0',
  boxSizing: 'border-box',
  fontSize: '14px',
  border: '1px solid #ccc'
};

var HrStyle = {
  borderBottom: '1px dashed #dee5e7',
  borderTop: 'none',
  borderLeft: 'none',
  borderRight: 'none',
  backgroundColor: 'transparent',
  width: '100%',
  height: '2px',
  fontSize: 0,
  overflow: 'hidden',
  marginTop: '0',
  marginBottom: '15px'
};

var PasswordCustomComponent = function PasswordCustomComponent(props) {
  return _react2.default.createElement('input', (0, _extends3.default)({ type: 'password', style: inputStyle }, props));
};

var required = function required(val) {
  return val && val.length;
};
var length = function length(val) {
  return val && val.length > 7;
};
var passwordsMatch = function passwordsMatch(_ref) {
  var newpassword = _ref.newpassword,
      confirmpassword = _ref.confirmpassword;

  return newpassword === confirmpassword;
};
var errorComponent = function errorComponent(props) {
  return _react2.default.createElement(
    'div',
    { style: { color: 'red' } },
    props.children
  );
};

var ChangePassword = function (_Component) {
  (0, _inherits3.default)(ChangePassword, _Component);

  function ChangePassword(props) {
    (0, _classCallCheck3.default)(this, ChangePassword);

    var _this = (0, _possibleConstructorReturn3.default)(this, (ChangePassword.__proto__ || (0, _getPrototypeOf2.default)(ChangePassword)).call(this, props));

    _this.state = {
      score: 0,
      suggestions: []
    };
    return _this;
  }

  (0, _createClass3.default)(ChangePassword, [{
    key: 'handleSubmit',
    value: function handleSubmit(changePassword) {
      this.props.dispatch((0, _actions.shouldChangePassword)(changePassword));
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          newpassword = _props.newpassword,
          isChangingPassword = _props.isChangingPassword,
          isChangingPasswordSucceed = _props.isChangingPasswordSucceed,
          isChangingPasswordError = _props.isChangingPasswordError;


      var score = void 0;
      var suggestions = void 0;
      var errorContent = isChangingPasswordError && _react2.default.createElement(
        'div',
        { style: { margin: '15px 0' } },
        _react2.default.createElement(
          _Alert2.default,
          { type: 'danger' },
          'Oops, something went wrong, please contact our support.'
        )
      );
      var successContent = isChangingPasswordSucceed && _react2.default.createElement(
        'div',
        { style: { margin: '15px 0' } },
        _react2.default.createElement(
          _Alert2.default,
          { type: 'success' },
          'You password has been changed.'
        )
      );
      var loading = isChangingPassword && _react2.default.createElement(_MiniLoading2.default, null);

      if (newpassword) {
        var passwordAudit = (0, _zxcvbn2.default)(newpassword);
        score = passwordAudit.score;
        suggestions = passwordAudit.feedback.suggestions;
      }

      return _react2.default.createElement(
        _reactReduxForm.Form,
        { model: 'changePassword',
          onSubmit: function onSubmit(changePassword) {
            return _this2.handleSubmit(changePassword);
          },
          validators: { '': { passwordsMatch: passwordsMatch } } },
        errorContent,
        successContent,
        _react2.default.createElement(
          _FormDecorator2.default,
          { isRequired: true, label: 'Current Password' },
          _react2.default.createElement(_reactReduxForm.Control, { component: PasswordCustomComponent, model: 'changePassword.oldpassword', validators: { required: required } }),
          _react2.default.createElement(_reactReduxForm.Errors, {
            model: 'changePassword.oldpassword',
            show: 'touched',
            wrapper: errorComponent,
            messages: {
              required: 'Please provide a password.'
            }
          })
        ),
        _react2.default.createElement('hr', { style: HrStyle }),
        _react2.default.createElement(
          'div',
          { style: { display: 'flex' } },
          _react2.default.createElement(
            'div',
            { style: { flex: 1 } },
            _react2.default.createElement(
              _FormDecorator2.default,
              { isRequired: true, label: 'New Password' },
              _react2.default.createElement(_reactReduxForm.Control, { component: PasswordCustomComponent, model: 'changePassword.newpassword',
                validators: { required: required, length: length } }),
              _react2.default.createElement(_reactReduxForm.Errors, {
                model: 'changePassword.newpassword',
                show: 'touched',
                wrapper: errorComponent,
                messages: {
                  required: 'Please provide a valid new password.',
                  length: 'Password must me minimum 8 characters'
                }
              })
            ),
            _react2.default.createElement(
              _FormDecorator2.default,
              { isRequired: true, label: 'Confirm New Password' },
              _react2.default.createElement(_reactReduxForm.Control, { component: PasswordCustomComponent,
                model: 'changePassword.confirmpassword' }),
              _react2.default.createElement(_reactReduxForm.Errors, {
                model: 'changePassword',
                show: 'touched',
                wrapper: errorComponent,
                messages: { passwordsMatch: 'Should be the same password as above.' }
              })
            ),
            _react2.default.createElement('hr', { style: HrStyle }),
            _react2.default.createElement(_Button2.default, {
              type: 'primary',
              message: 'Change Password',
              click: function click(changePassword) {
                return _this2.handleSubmit(changePassword);
              }
            }),
            _react2.default.createElement(
              'span',
              { style: { marginLeft: '15px' } },
              loading
            )
          ),
          _react2.default.createElement(
            'div',
            { style: { width: '400px', padding: '15px', margin: '15px', background: '#f2f2f2', borderRadius: '2px' } },
            _react2.default.createElement(_PasswordAdviser2.default, { score: score, suggestions: suggestions })
          )
        )
      );
    }
  }]);
  return ChangePassword;
}(_react.Component);

var select = function select(_ref2) {
  var changePassword = _ref2.changePassword,
      user = _ref2.user;
  return {
    newpassword: changePassword.newpassword,
    isChangingPassword: user.isChangingPassword,
    isChangingPasswordSucceed: user.isChangingPasswordSucceed,
    isChangingPasswordError: user.isChangingPasswordError
  };
};

exports.default = (0, _reactRedux.connect)(select)(ChangePassword);