'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Dialog = require('material-ui/Dialog');

var _Dialog2 = _interopRequireDefault(_Dialog);

var _FlatButton = require('material-ui/FlatButton');

var _FlatButton2 = _interopRequireDefault(_FlatButton);

var _Form = require('cluedin-ui/Form/Form');

var _Form2 = _interopRequireDefault(_Form);

var _Toggle = require('material-ui/Toggle');

var _Toggle2 = _interopRequireDefault(_Toggle);

var _validation = require('cluedin-core/iso/validation');

var _validation2 = _interopRequireDefault(_validation);

var _Alert = require('cluedin-ui/Alert');

var _Alert2 = _interopRequireDefault(_Alert);

var _reactRedux = require('react-redux');

var _reducers = require('../reducers');

var _fromServer = require('cluedin-core/fromServer');

var _actions = require('../actions');

var _MiniLoading = require('cluedin-ui/Loading/MiniLoading');

var _MiniLoading2 = _interopRequireDefault(_MiniLoading);

var _reactIntl = require('react-intl');

var _EmailComponent = require('../components/EmailComponent');

var _EmailComponent2 = _interopRequireDefault(_EmailComponent);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var InviteUserDialog = function (_Component) {
  (0, _inherits3.default)(InviteUserDialog, _Component);

  function InviteUserDialog() {
    var _ref;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, InviteUserDialog);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = InviteUserDialog.__proto__ || (0, _getPrototypeOf2.default)(InviteUserDialog)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      showError: false,
      error: false,
      email: ''
    }, _this.handleClose = function () {
      _this.setState({
        email: '',
        showError: false,
        error: false
      });

      _this.props.dispatch((0, _actions.shouldCloseInviteUserDialog)());
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(InviteUserDialog, [{
    key: 'componentWillMount',
    value: function componentWillMount() {
      this.props.dispatch((0, _actions.shouldFetchCurrentUser)());
    }
  }, {
    key: 'onFormUpdateHandler',
    value: function onFormUpdateHandler(value) {
      if (!value.email || !_validation2.default.isEmail(value.email)) {
        this.setState({ error: true });
      } else {
        this.setState({ error: false, email: value.email });
      }
    }
  }, {
    key: 'handleAddTeamMember',
    value: function handleAddTeamMember() {
      var currentUser = this.props.currentUser;


      if (this.state.error) {
        this.setState({
          showError: true
        });
      } else {
        if (!this.state.email) {
          this.setState({
            showError: true
          });
        } else {
          this.setState({
            showError: false
          });

          this.props.dispatch((0, _actions.checkIfEmailExistAndSendInvitation)({
            orgName: _fromServer.clientId,
            email: this.state.email,
            userName: currentUser.client.UserName,
            isAdmin: this.state.isAdministrator
          }));
        }
      }
    }
  }, {
    key: 'onToggleHandler',
    value: function onToggleHandler(event, value) {
      this.setState({
        isAdministrator: value
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var showError = this.state.showError;
      var _props = this.props,
          inviteUsers = _props.inviteUsers,
          isOpenInviteUserDialog = _props.isOpenInviteUserDialog,
          emailAlreadyTakenForInviteUsers = _props.emailAlreadyTakenForInviteUsers,
          inviteUserSomethingIsWrong = _props.inviteUserSomethingIsWrong,
          inviteUserFeedValueEmail = _props.inviteUserFeedValueEmail,
          inviteUserFeedValueName = _props.inviteUserFeedValueName;


      var alertContent = void 0;
      var actions = void 0;
      var disabledButton = void 0;
      var loadingContent = void 0;
      var inviteFriendsContent = void 0;

      if (showError) {
        alertContent = _react2.default.createElement(
          'div',
          { style: { marginBottom: '15px' } },
          _react2.default.createElement(
            _Alert2.default,
            { type: 'error' },
            _react2.default.createElement(_reactIntl.FormattedMessage, { id: 'InviteUserDialog.EnterValidEmail' })
          )
        );
      } else {
        if (emailAlreadyTakenForInviteUsers) {
          alertContent = _react2.default.createElement(
            'div',
            { style: { marginBottom: '15px' } },
            _react2.default.createElement(
              _Alert2.default,
              { type: 'error' },
              _react2.default.createElement(_reactIntl.FormattedMessage, {
                id: 'InviteUserDialog.EmailAlreadyInvited',
                values: { email: emailAlreadyTakenForInviteUsers }
              })
            )
          );
        }

        if (inviteUserSomethingIsWrong) {
          alertContent = _react2.default.createElement(
            'div',
            { style: { marginBottom: '15px' } },
            _react2.default.createElement(
              _Alert2.default,
              { type: 'error' },
              _react2.default.createElement(_reactIntl.FormattedMessage, { id: 'InviteUserDialog.SomethingWrong' })
            )
          );
        }
      }

      var isLoadingCurrentInvite = inviteUsers[this.state.email];

      if (isLoadingCurrentInvite && isLoadingCurrentInvite.isFetching) {
        disabledButton = true;
        loadingContent = _react2.default.createElement(
          'span',
          { style: { position: 'relative' } },
          _react2.default.createElement(_MiniLoading2.default, { style: { position: 'absolute', right: '3px', top: '3px' } })
        );
      }

      actions = [loadingContent, _react2.default.createElement(_FlatButton2.default, {
        label: _react2.default.createElement(_reactIntl.FormattedMessage, { id: 'InviteUserDialog.Cancel' }),
        disabled: disabledButton,
        onTouchTap: this.handleClose.bind(this)
      }), _react2.default.createElement(_FlatButton2.default, {
        label: _react2.default.createElement(_reactIntl.FormattedMessage, { id: 'InviteUserDialog.AddTeamMember' }),
        primary: true,
        keyboardFocused: true,
        disabled: disabledButton,
        onTouchTap: this.handleAddTeamMember.bind(this)
      })];

      if (inviteUserFeedValueName && inviteUserFeedValueEmail) {
        inviteFriendsContent = _react2.default.createElement(
          _Alert2.default,
          null,
          _react2.default.createElement(_reactIntl.FormattedMessage, {
            id: 'InviteUserDialog.AboutToInvite',
            values: { inviteUserFeedValueName: inviteUserFeedValueName }
          })
        );
      }

      if (inviteUserFeedValueName && !inviteUserFeedValueEmail) {
        inviteFriendsContent = _react2.default.createElement(
          _Alert2.default,
          { type: 'warning' },
          _react2.default.createElement(_reactIntl.FormattedMessage, {
            id: 'InviteUserDialog.AboutToInviteWithoutEmail',
            values: { name: _react2.default.createElement(
                'span',
                { style: { textDecoration: 'underline' } },
                inviteUserFeedValueName
              ) }
          })
        );
      }

      return _react2.default.createElement(
        _Dialog2.default,
        {
          title: _react2.default.createElement(
            'div',
            { style: { background: 'rgb(88, 102, 110)', borderRadius: '2px 2px 0px 0px', color: 'rgb(255, 255, 255)', padding: '15px 10px', marginBottom: '15px' } },
            _react2.default.createElement(_reactIntl.FormattedMessage, { id: 'InviteUserDialog.AddTeamMember' })
          ),
          actions: actions,
          modal: false,
          open: isOpenInviteUserDialog,
          onRequestClose: this.handleClose,
          className: '__test_inviteUserDialog'
        },
        alertContent,
        inviteFriendsContent,
        _react2.default.createElement(
          'div',
          { style: { marginTop: '15px' } },
          _react2.default.createElement(_Form2.default, {
            onFormUpdate: this.onFormUpdateHandler.bind(this),
            onSubmit: this.handleAddTeamMember.bind(this),
            fields: [{ type: 'Email', name: 'email', isRequired: true, displayName: 'Email' }],
            feedValues: { email: inviteUserFeedValueEmail }
          }),
          _react2.default.createElement(_Toggle2.default, {
            label: _react2.default.createElement(_reactIntl.FormattedMessage, { id: 'InviteUserDialog.InviteAsAdmin' }),
            onToggle: this.onToggleHandler.bind(this),
            defaultToggled: false
          }),
          _react2.default.createElement(
            'p',
            null,
            _react2.default.createElement(
              'strong',
              null,
              _react2.default.createElement(_reactIntl.FormattedMessage, { id: 'InviteUserDialog.WhyAdmin' })
            ),
            _react2.default.createElement(_reactIntl.FormattedMessage, { id: 'InviteUserDialog.WhyAdminExplanation' })
          )
        )
      );
    }
  }]);
  return InviteUserDialog;
}(_react.Component);

process.env.NODE_ENV !== "production" ? InviteUserDialog.propTypes = {
  inviteUsers: _propTypes2.default.object,
  isEmailExisting: _propTypes2.default.object,
  isOpenInviteUserDialog: _propTypes2.default.bool,
  emailAlreadyTakenForInviteUsers: _propTypes2.default.string,
  inviteUserSomethingIsWrong: _propTypes2.default.bool,
  dispatch: _propTypes2.default.func,
  inviteUserFeedValueEmail: _propTypes2.default.string,
  inviteUserFeedValueName: _propTypes2.default.string
} : void 0;


var select = function select(_ref2) {
  var _ref2$storeName = _ref2[_reducers.storeName],
      inviteUsers = _ref2$storeName.inviteUsers,
      isEmailExisting = _ref2$storeName.isEmailExisting,
      isOpenInviteUserDialog = _ref2$storeName.isOpenInviteUserDialog,
      emailAlreadyTakenForInviteUsers = _ref2$storeName.emailAlreadyTakenForInviteUsers,
      inviteUserSomethingIsWrong = _ref2$storeName.inviteUserSomethingIsWrong,
      inviteUserFeedValueEmail = _ref2$storeName.inviteUserFeedValueEmail,
      inviteUserFeedValueName = _ref2$storeName.inviteUserFeedValueName,
      currentUser = _ref2$storeName.currentUser;

  return {
    inviteUsers: inviteUsers,
    isEmailExisting: isEmailExisting,
    isOpenInviteUserDialog: isOpenInviteUserDialog,
    emailAlreadyTakenForInviteUsers: emailAlreadyTakenForInviteUsers,
    inviteUserSomethingIsWrong: inviteUserSomethingIsWrong,
    inviteUserFeedValueEmail: inviteUserFeedValueEmail,
    inviteUserFeedValueName: inviteUserFeedValueName,
    currentUser: currentUser
  };
};

exports.default = (0, _reactRedux.connect)(select)(InviteUserDialog);