'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _AllUsers = require('./AllUsers');

var _AllUsers2 = _interopRequireDefault(_AllUsers);

var _AllPotentialUsers = require('./AllPotentialUsers');

var _AllPotentialUsers2 = _interopRequireDefault(_AllPotentialUsers);

var _AllInvitations = require('./AllInvitations');

var _AllInvitations2 = _interopRequireDefault(_AllInvitations);

var _Tabs = require('cluedin-ui/Tabs');

var _reactIntl = require('react-intl');

var _reactRedux = require('react-redux');

var _reducers = require('../reducers');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var UserSectionStyle = {
  tabContainer: {
    margin: '15px 30px'
  }
};

var UserSection = function (_Component) {
  (0, _inherits3.default)(UserSection, _Component);

  function UserSection() {
    (0, _classCallCheck3.default)(this, UserSection);
    return (0, _possibleConstructorReturn3.default)(this, (UserSection.__proto__ || (0, _getPrototypeOf2.default)(UserSection)).apply(this, arguments));
  }

  (0, _createClass3.default)(UserSection, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          isAdmin = _props.isAdmin,
          isUsingSSO = _props.isUsingSSO;


      if (isAdmin) {
        var tabContent = void 0;
        var tabPanelContent = void 0;

        if (isUsingSSO) {
          tabContent = _react2.default.createElement(
            _Tabs.TabList,
            null,
            _react2.default.createElement(
              _Tabs.Tab,
              { key: 'AllUsersTab' },
              _react2.default.createElement(_reactIntl.FormattedMessage, { id: 'UserSection.Tab.Users' })
            )
          );
          tabPanelContent = [_react2.default.createElement(
            _Tabs.TabPanel,
            { key: 'AllUsers' },
            _react2.default.createElement(_AllUsers2.default, null)
          )];
        } else {
          tabContent = _react2.default.createElement(
            _Tabs.TabList,
            null,
            _react2.default.createElement(
              _Tabs.Tab,
              { key: 'AllUsersTab' },
              _react2.default.createElement(_reactIntl.FormattedMessage, { id: 'UserSection.Tab.Users' })
            ),
            _react2.default.createElement(
              _Tabs.Tab,
              { key: 'AllInvitationsTab' },
              _react2.default.createElement(_reactIntl.FormattedMessage, { id: 'UserSection.Tab.Invitations' })
            ),
            _react2.default.createElement(
              _Tabs.Tab,
              { key: 'AllPotentialsUsersTab' },
              _react2.default.createElement(_reactIntl.FormattedMessage, { id: 'UserSection.Tab.PotentialUsers' })
            )
          );
          tabPanelContent = [_react2.default.createElement(
            _Tabs.TabPanel,
            { key: 'AllUsers' },
            _react2.default.createElement(
              'div',
              { style: UserSectionStyle.tabContainer },
              _react2.default.createElement(_AllUsers2.default, null)
            )
          ), _react2.default.createElement(
            _Tabs.TabPanel,
            { key: 'AllInvitation' },
            _react2.default.createElement(
              'div',
              { style: UserSectionStyle.tabContainer },
              _react2.default.createElement(_AllInvitations2.default, null)
            )
          ), _react2.default.createElement(
            _Tabs.TabPanel,
            { key: 'AllPotentialsUSer' },
            _react2.default.createElement(
              'div',
              { style: UserSectionStyle.tabContainer },
              _react2.default.createElement(_AllPotentialUsers2.default, null)
            )
          )];
        }
        return _react2.default.createElement(
          'div',
          null,
          _react2.default.createElement(
            _Tabs.Tabs,
            { isMainStyle: true },
            tabContent,
            tabPanelContent
          )
        );
      } else {
        return _react2.default.createElement(
          'div',
          null,
          _react2.default.createElement(
            _Tabs.Tabs,
            { isMainStyle: true },
            _react2.default.createElement(
              _Tabs.TabList,
              null,
              _react2.default.createElement(
                _Tabs.Tab,
                null,
                _react2.default.createElement(_reactIntl.FormattedMessage, { id: 'UserSection.Tab.Users' })
              )
            ),
            _react2.default.createElement(
              _Tabs.TabPanel,
              null,
              _react2.default.createElement(
                'div',
                { style: UserSectionStyle.tabContainer },
                _react2.default.createElement(_AllUsers2.default, null)
              )
            )
          )
        );
      }
    }
  }]);
  return UserSection;
}(_react.Component);

var select = function select(_ref) {
  var currentUser = _ref[_reducers.storeName].currentUser;

  return {
    isAdmin: currentUser && currentUser.client ? currentUser.client.IsAdmin : false
  };
};

exports.default = (0, _reactRedux.connect)(select)(UserSection);